#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
###########################################################
#      Coded by https://github.com/su1s/e2m3u2bouquet     #
#                                                         #
#	modified by audi06_19 2019                        #
#	Support: www.dreamosat-forum.com                  #
#	E-Mail: admin@dreamosat-forum.com                 #
###########################################################
import sys
from cStringIO import StringIO
import threading
logfile = StringIO()
mutex = threading.Lock()

def write(data):
    mutex.acquire()
    try:
        if logfile.tell() > 2000:
            logfile.reset()
        logfile.write(data)
    finally:
        mutex.release()

    sys.stdout.write(data)


def getvalue():
    mutex.acquire()
    try:
        pos = logfile.tell()
        head = logfile.read()
        logfile.reset()
        tail = logfile.read(pos)
    finally:
        mutex.release()

    return head + tail
